import { AmqpConnection } from '@golevelup/nestjs-rabbitmq';
import { Injectable } from '@nestjs/common';
import { ConfigService } from '@nestjs/config';
import { IMessageBroker } from '../../domain/interfaces/message-broker';

@Injectable()
export class Messager extends IMessageBroker {
  constructor(
    private readonly _amqpConnection: AmqpConnection,
    configService: ConfigService,
  ) {
    super(configService.get<string>('RMQ_EXCHANGE'));
  }

  publish(routingKey: string, message: string): void {
    this._amqpConnection.publish(this.exchange, routingKey, message);
  }
}
