import { QueryHandler } from '@nestjs/cqrs';
import { ICollection } from 'src/modules/database/src/interfaces/collection.interface';
import { TerritoriesRepository } from '../../adapters/secondaries/territories.repository';
import { FindAllTerritoriesQuery } from '../../queries/find-all-territories.query';
import { Territory } from '../entities/territory';

@QueryHandler(FindAllTerritoriesQuery)
export class FindAllTerritoriesUseCase {
  constructor(private readonly _repository: TerritoriesRepository) {}

  async execute(
    findAllTerritoriesQuery: FindAllTerritoriesQuery,
  ): Promise<ICollection<Territory>> {
    return this._repository.findAll(
      findAllTerritoriesQuery.page,
      findAllTerritoriesQuery.perPage,
    );
  }
}
